=== debian/changelog ===
libhugetlbfs (2.20-4.lnd.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Add support for loongarch64

 -- Zhang Na <zhangna@loongson.cn>  Thu, 10 Feb 2022 10:08:09 +0800

libhugetlbfs (2.20-4) unstable; urgency=medium

  * Restrict Architecture on all binary packages

 -- Punit Agrawal <punit@debian.org>  Sat, 28 Oct 2017 07:03:56 +0100

libhugetlbfs (2.20-3) unstable; urgency=medium

  * Restrict build architectures (Closes: #879939)

 -- Punit Agrawal <punit@debian.org>  Fri, 27 Oct 2017 22:11:38 +0100

libhugetlbfs (2.20-2) unstable; urgency=medium

  * Drop dependency on dh-exec
  * Mark libhugetlbfs-dev to be Architecture: same
  * Update Standards-Version to 4.1.1
  * Provide links to package repository

 -- Punit Agrawal <punit@debian.org>  Thu, 26 Oct 2017 22:12:46 +0100

libhugetlbfs (2.20-1) unstable; urgency=medium

  * Initial release (Closes: #533708)

 -- Punit Agrawal <punit@debian.org>  Thu, 21 Sep 2017 21:24:46 +0000
