## libhugetlbfs 2.21

=== debian/changelog ===
libhugetlbfs (2.21-0ubuntu1) eoan; urgency=medium

  * New upstream release LP: #1825216
  * Switch watch file to github
  * Update packaging to debhelper 11

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 30 Apr 2019 14:06:38 +0100

libhugetlbfs (2.19-0ubuntu2) disco; urgency=medium

  * Enable s390x build.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Thu, 04 Apr 2019 13:26:17 +0100
