=== debian/control ===
Source: libhugetlbfs
Priority: extra
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Frank Lin PIAT <fpiat@klabs.be>, Vincent Danjean <Vincent.Danjean@ens-lyon.org>
Build-Depends: debhelper (>= 11), dh-python, python
Standards-Version: 4.3.0
Section: libs
Homepage: http://libhugetlbfs.sourceforge.net/

Package: libhugetlbfs0
Section: libs
Architecture: i386 amd64 powerpc ppc64 ppc64el armhf arm64 s390x
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: hugepages
Description: A library which provides easy access to huge pages of memory
 libhugetlbfs is a library which provides easy access to huge pages of memory.
 It is a wrapper for the hugetlbfs file system. Applications can use huge pages
 to fulfill malloc() requests without being recompiled by using LD_PRELOAD.
 Alternatively, applications can be linked against libhugetlbfs without source
 modifications to load BSS or BSS, data, and text segments into large pages.
 .
 This package provides the applications for preloading libhugetlbfs

Package: libhugetlbfs-tests
Section: libs
Architecture: i386 amd64 powerpc ppc64 ppc64el armhf arm64 s390x
Depends: ${shlibs:Depends}, ${misc:Depends}, hugepages, ${python:Depends}
Recommends: libhugetlbfs0
Suggests: oprofile
Description: A library which provides easy access to huge pages of memory
 libhugetlbfs is a library which provides easy access to huge pages of memory.
 It is a wrapper for the hugetlbfs file system. Applications can use huge pages
 to fulfill malloc() requests without being recompiled by using LD_PRELOAD.
 Alternatively, applications can be linked against libhugetlbfs without source
 modifications to load BSS or BSS, data, and text segments into large pages.
 . 
 This package provides the test-suite for libhugetlbfs, which is mostly useful
 for regression testing of libhugetlbfs.

Package: hugepages
Section: admin
Architecture: i386 amd64 powerpc ppc64 ppc64el armhf arm64 s390x
Depends: ${shlibs:Depends}, ${misc:Depends}, libhugetlbfs0 (= ${binary:Version}), ${python:Depends}
Suggests: libhugetlbfs-tests
Description: A set of tools to configure huge pages of memory
 This package contains a number of utilities that will help administrate the
 use of huge pages on your system.  hugeedit modifies binaries to set default
 segment remapping behavior. hugectl sets environment variables for using huge
 pages and then execs the target program. hugeadm gives easy access to huge page
 pool size control. pagesize lists page sizes available on the machine.

Package: libhugetlbfs-dev
Section: libdevel
Architecture: i386 amd64 powerpc ppc64 ppc64el armhf arm64 s390x
Depends: libhugetlbfs0 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: A library which provides easy access to huge pages of memory
 libhugetlbfs is a library which provides easy access to huge pages of memory.
 It is a wrapper for the hugetlbfs file system. Applications can use huge pages
 to fulfill malloc() requests without being recompiled by using LD_PRELOAD.
 Alternatively, applications can be linked against libhugetlbfs without source
 modifications to load BSS or BSS, data, and text segments into large pages.
 .
 This package provides the headers and development libraries
