=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%libhugetlbfs-$1.tar.gz%" \
      https://github.com/libhugetlbfs/libhugetlbfs/tags \
      (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
