=== debian/changelog ===
libhugetlbfs (2.22-1) unstable; urgency=medium

  * New upstream version 2.22
  * Update to python3 dependency (Closes: #936874)
  * Update debhelper compat version to 12

 -- Punit Agrawal <punit@debian.org>  Mon, 16 Sep 2019 06:57:13 +0900

libhugetlbfs (2.21-4) unstable; urgency=medium

  * Correct version of Breaks+Replaces tags

 -- Punit Agrawal <punit@debian.org>  Sun, 08 Sep 2019 08:52:28 +0900

libhugetlbfs (2.21-3) unstable; urgency=medium

  * Add Breaks+Replaces tag for libhugetlbfs-bin (Closes: #938953)

 -- Punit Agrawal <punit@debian.org>  Sun, 08 Sep 2019 07:36:09 +0900

libhugetlbfs (2.21-2) unstable; urgency=medium

  * Move ld.hugetlbfs to libhugetlbfs-bin
  * Update Standards-Version to 4.4.0

 -- Punit Agrawal <punit@debian.org>  Sat, 24 Aug 2019 09:44:09 +0900

libhugetlbfs (2.21-1) unstable; urgency=medium

  * New upstream version 2.21
  * Install executable script to /usr/bin

 -- Punit Agrawal <punit@debian.org>  Sun, 24 Mar 2019 08:24:30 +0900
