=== debian/changelog ===
libhugetlbfs (2.23-4) unstable; urgency=medium

  [ Simon Josefsson ]
  * Mention names of CLI tools in description (Closes: #977342)

 -- Punit Agrawal <punit@debian.org>  Mon, 14 Dec 2020 19:48:59 +0900

libhugetlbfs (2.23-3) unstable; urgency=medium

  * Update patches for new upstream release 2.23

 -- Punit Agrawal <punit@debian.org>  Sun, 08 Nov 2020 09:03:51 +0900

libhugetlbfs (2.23-2) unstable; urgency=medium

  * Enable package for riscv64

 -- Punit Agrawal <punit@debian.org>  Sat, 07 Nov 2020 13:24:08 +0900

libhugetlbfs (2.23-1) unstable; urgency=medium

  * New upstream version 2.23
  * Update standards version to 4.5.0

 -- Punit Agrawal <punit@debian.org>  Sun, 01 Nov 2020 16:46:13 +0900
