=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
include /usr/share/dpkg/pkg-info.mk

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

export BUILDTYPE=NATIVEONLY
export V=1
export DH_VERBOSE=1

%:
	dh $@

override_dh_auto_clean:
	make -j1 clean

override_dh_auto_make:
	make libs tools

override_dh_auto_install:
ifeq ($(DEB_HOST_ARCH_BITS),64)
	$(MAKE) PREFIX=/usr DESTDIR=$(CURDIR)/debian/tmp LIB64=lib/$(DEB_HOST_MULTIARCH) install
else
	$(MAKE) PREFIX=/usr DESTDIR=$(CURDIR)/debian/tmp LIB32=lib/$(DEB_HOST_MULTIARCH) install
endif
	rm debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/libhugetlbfs_privutils.so
	mv debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/libhugetlbfs.so debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/libhugetlbfs-$(DEB_VERSION_UPSTREAM).so
	ln -s libhugetlbfs-$(DEB_VERSION_UPSTREAM).so debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/libhugetlbfs.so.0
	ln -s libhugetlbfs.so.0 debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/libhugetlbfs.so
	dh_install
