## libhugetlbfs 2.24

=== debian/changelog ===
libhugetlbfs (2.24-1) unstable; urgency=medium

  * New upstream version 2.24
  * debian: Enable builds for loong64 (Closes: #1065601)
  * debian: Dropped feature merged upstream
  * debian: Update rules for new upstream release

 -- Punit Agrawal <punit@debian.org>  Sat, 30 Mar 2024 07:47:00 +0000

libhugetlbfs (2.23-5) unstable; urgency=medium

  * Disable malloc if __morecore hook not available (Closes: #1017324)

 -- Punit Agrawal <punit@debian.org>  Sun, 11 Sep 2022 23:39:38 +0100
