=== debian/rules ===
--- 
+++ 
@@ -21,9 +21,6 @@
 %:
 	dh $@
 
-override_dh_auto_clean:
-	make -j1 clean
-
 override_dh_auto_make:
 	make libs tools
